// This file is generated by kconfig_compiler from kcalc.kcfg.
// All changes you do to this file will be lost.
#ifndef KCALCSETTINGS_H
#define KCALCSETTINGS_H

#include <kconfigskeleton.h>
#include <kdebug.h>

#include <kapplication.h>
#include <kglobalsettings.h>
#include <config.h>
class KCalcSettings : public KConfigSkeleton
{
  public:

    static KCalcSettings *self();
    ~KCalcSettings();


    /**
      Get The foreground color of the display.
    */
    static
    QColor foreColor()
    {
      return self()->mForeColor;
    }


    /**
      Get The background color of the display.
    */
    static
    QColor backColor()
    {
      return self()->mBackColor;
    }


    /**
      Get The color of number buttons.
    */
    static
    QColor numberButtonsColor()
    {
      return self()->mNumberButtonsColor;
    }


    /**
      Get The color of function buttons.
    */
    static
    QColor functionButtonsColor()
    {
      return self()->mFunctionButtonsColor;
    }


    /**
      Get The color of statistical buttons.
    */
    static
    QColor statButtonsColor()
    {
      return self()->mStatButtonsColor;
    }


    /**
      Get The color of hex buttons.
    */
    static
    QColor hexButtonsColor()
    {
      return self()->mHexButtonsColor;
    }


    /**
      Get The color of memory buttons.
    */
    static
    QColor memoryButtonsColor()
    {
      return self()->mMemoryButtonsColor;
    }


    /**
      Get The color of operation buttons.
    */
    static
    QColor operationButtonsColor()
    {
      return self()->mOperationButtonsColor;
    }


    /**
      Get The font to use in the display.
    */
    static
    QFont font()
    {
      return self()->mFont;
    }


    /**
      Get Maximum number of digits displayed.
    */
    static
    uint precision()
    {
      return self()->mPrecision;
    }


    /**
      Get Number of fixed decimal digits.
    */
    static
    uint fixedPrecision()
    {
      return self()->mFixedPrecision;
    }


    /**
      Get Whether to use fixed decimal places.
    */
    static
    bool fixed()
    {
      return self()->mFixed;
    }


    /**
      Get Whether to beep on error.
    */
    static
    bool beep()
    {
      return self()->mBeep;
    }


    /**
      Get Whether to show the result in the window title.
    */
    static
    bool captionResult()
    {
      return self()->mCaptionResult;
    }


    /**
      Get Whether to group digits.
    */
    static
    bool groupDigits()
    {
      return self()->mGroupDigits;
    }

    /**
      Set Whether to show statistical buttons.
    */
    static
    void setShowStat( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ShowStat" ) ))
        self()->mShowStat = v;
    }

    /**
      Get Whether to show statistical buttons.
    */
    static
    bool showStat()
    {
      return self()->mShowStat;
    }

    /**
      Set Whether to show buttons with functions used in science/engineering,
	     like exp, log, sin etc.
    */
    static
    void setShowScientific( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ShowScientific" ) ))
        self()->mShowScientific = v;
    }

    /**
      Get Whether to show buttons with functions used in science/engineering,
	     like exp, log, sin etc.
    */
    static
    bool showScientific()
    {
      return self()->mShowScientific;
    }

    /**
      Set Whether to show logic buttons.
    */
    static
    void setShowLogic( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ShowLogic" ) ))
        self()->mShowLogic = v;
    }

    /**
      Get Whether to show logic buttons.
    */
    static
    bool showLogic()
    {
      return self()->mShowLogic;
    }

    /**
      Set Whether to show constant buttons.
    */
    static
    void setShowConstants( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ShowConstants" ) ))
        self()->mShowConstants = v;
    }

    /**
      Get Whether to show constant buttons.
    */
    static
    bool showConstants()
    {
      return self()->mShowConstants;
    }

    /**
      Set Name of the user programmable constants.
    */
    static
    void setNameConstant( int i, const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "nameConstant%1" ).arg( i ) ))
        self()->mNameConstant[i] = v;
    }

    /**
      Get Name of the user programmable constants.
    */
    static
    QString nameConstant( int i )
    {
      return self()->mNameConstant[i];
    }

    /**
      Set List of user programmable constants
    */
    static
    void setValueConstant( int i, const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "valueConstant%1" ).arg( i ) ))
        self()->mValueConstant[i] = v;
    }

    /**
      Get List of user programmable constants
    */
    static
    QString valueConstant( int i )
    {
      return self()->mValueConstant[i];
    }

    static
    void writeConfig()
    {
      static_cast<KConfigSkeleton*>(self())->writeConfig();
    }
  protected:
    KCalcSettings();
    static KCalcSettings *mSelf;


    // Colors
    QColor mForeColor;
    QColor mBackColor;
    QColor mNumberButtonsColor;
    QColor mFunctionButtonsColor;
    QColor mStatButtonsColor;
    QColor mHexButtonsColor;
    QColor mMemoryButtonsColor;
    QColor mOperationButtonsColor;

    // Font
    QFont mFont;

    // Precision
    uint mPrecision;
    uint mFixedPrecision;
    bool mFixed;

    // General
    bool mBeep;
    bool mCaptionResult;
    bool mGroupDigits;
    bool mShowStat;
    bool mShowScientific;
    bool mShowLogic;
    bool mShowConstants;

    // UserConstants
    QString mNameConstant[6];
    QString mValueConstant[6];

  private:
};

#endif

